<template>
  <div>
    <div class="flex flex-col items-stretch px-6 py-4">
      <calendar class="" @date-click="dateClick($event)" :value="value" />

      <div @click="modals.show('time-picker', $event)" class="flex flex-row items-center">
        <i class="hero outline clock"></i>
        <div role="textbox" class="bg-gray-200 px-3 py-2 rounded text-sm ml-4 flex-1 text-gray-900 clickable">
          {{ value.toLocaleString({ hour: "2-digit", minute: "2-digit" }) }}
        </div>
      </div>
    </div>

    <modal :is="modals.inlined('time-picker')" dimmed position="center">
      <time-picker
        :value="value"
        @cancel="modals.hide('time-picker')"
        @input="
          timeInput($event);
          modals.hide('time-picker');
        "
      />
    </modal>

    <actions>
      <button @click="$emit('input', value)" class="button">Done</button>
      <button @click="$emit('cancel')" class="text-button text-gray-800">Cancel</button>
    </actions>
  </div>
</template>

<script lang="ts">
import { DateTime } from "luxon";
import { computed, ref } from "vue";
import Calendar from "@/components/Calendar.vue";
import Actions from "@/use/modal/components/Actions.vue";
import TimePicker from "./TimePicker.vue";
import { useModals } from "@/use/modal";

export default {
  components: {
    Calendar,
    Actions,
    TimePicker
  },
  emits: ["input", "cancel"],
  props: {
    value: {
      type: DateTime,
      required: false
    }
  },
  setup(props) {
    const temporaryValue = ref<DateTime | null>(null);
    const value = computed(() => temporaryValue.value || (props.value as DateTime));

    return {
      modals: useModals({}),
      value,
      dateClick: (date: DateTime) => {
        temporaryValue.value = value.value.set({ year: date.year, month: date.month, day: date.day });
      },
      timeInput: (date: DateTime) => {
        temporaryValue.value = value.value.set({ hour: date.hour, minute: date.minute });
      }
    };
  }
};
</script>
